import factory

from jeeves.core.objects import Flow, Task
from jeeves.core.registry import ActionRegistry


class TaskFactory(factory.Factory):
    name = factory.Faker("name")
    type = factory.Iterator(ActionRegistry.actions)
    parameters = {"script": "#!/bin/bash\necho test"}

    class Meta:
        model = Task


class FlowFactory(factory.Factory):
    name = factory.Faker("name")
    tasks = factory.LazyFunction(lambda: [TaskFactory() for _ in range(0, 2)])

    class Meta:
        model = Flow
